angular.module('efekto', ['ionic', 'efekto.controllers', 'ngCordova', 'auth0.lock', 'angular-storage', 'angular-jwt', 'jett.ionic.filter.bar'])

	.run(function ($ionicPlatform, $state, $cordovaNetwork, store, lock, profileService, $ionicHistory, messageService) {
		$ionicPlatform.ready(function () {
			console.log("here");
			// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
			// for form inputs)
			if (window.cordova && window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
				cordova.plugins.Keyboard.disableScroll(true);

			}
			if (window.StatusBar) {
				// org.apache.cordova.statusbar required
				StatusBar.styleDefault();
			}
			console.log("Platform loaded routing to default")
			registerForPushNotifications() ;

			$state.go('app.home');
		});

		// Register for Push Notifications. Requires that phonegap-plugin-push be installed.
		var pushRegistration = null;
		var badgeCounter = 0;
		function registerForPushNotifications() {

			if (typeof PushNotification === 'undefined'){
			       return;
			}

			pushRegistration = PushNotification.init({
			    android: { senderID: "433952168894", badge: 'true' },
				ios: { alert: 'true', badge: 'true', sound: 'true' },
				wns: {}
			});



			// Handle the registration event.
			pushRegistration.on('registration', function (data) {
				console.log("registering"); 

				// Get the native platform of the device.
				var platform = device.platform;
				// Get the handle returned during registration.
				var handle = data.registrationId;
				store.set("handle", handle);	
				console.log(handle);

				console.log("handle set at " + store.get("handle"));
				//console.log(data.message);
			});

			pushRegistration.on('notification', function (data, d2) {
			    console.log('notification event');
			    if (data.additionalData.foreground) {
			       // navigator.notification.beep(1);
			    }
			    //var profile = store.get('profile');
			    //var isExpert = false;

			    //if (store.get('profile') && store.get('profile').groups) {
			    //    isExpert = store.get('profile').groups.includes("Expert");
			    //}

			    //if (profile) {
			    //    messageService.getTotalUnreadMessages(isExpert == true ? "User" : "Expert", isExpert == true ? "Expert" : profile.email).then(function (success) {
			    //        badgeCounter = success.data[0].TotalUnread;
			    //        pushRegistration.setApplicationIconBadgeNumber(function (s) {
			    //            console.info('Badge success', s);
			    //        }, function (error) {
			    //            console.error(error);
			    //        }, badgeCounter);
			    //    }, function (error) {
			    //    });
			    //};

			    });

			pushRegistration.on('error', function () { console.log("error") });
			
		}
		// register lock events
		lock.interceptHash();
		lock.on('authorization_error', function(result){
			console.log(JSON.stringify(result));	
		});	
		lock.on('authenticated', function(authResult) {
			store.set('token', authResult.idToken);
			lock.getProfile(authResult.idToken, function(error, profile) {
				if (error) {
		       		     console.log(error);
				}
				localStorage.setItem('profile', JSON.stringify(profile));
				store.set('profile', profile);
				store.set('token', authResult.idToken);
				console.log("logged in success");
				profileService.postProfile({
					"userid": profile.user_id, 
					"profile": JSON.stringify(profile), 
					"picture": profile.picture,
					"deviceid": store.get("handle")
				});

			});



		});

	})

	.config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, lockProvider, $ionicFilterBarConfigProvider) {


		// Authentication
		lockProvider.init({
			domain: 'efekto.eu.auth0.com',
			clientID: 'iMnWss6fFstgM6s5iERdLBWcXyeBUY27',
			options:{
				avatar: null,
				auth: { redirect: false },
				theme:{
					logo: 'http://schalkwykjc.github.io/img/efekto-logo.png',
					primaryColor: "#137e3e",
					autoclose: true,
					showIcon: false
				},
				
			}	       
		});

		//Called when login is successful
		/*		lockProvider.on('loginSuccess', [ 'profilePromise', 'idToken', function ( profilePromise, idToken) {
		// Successfully log in
		// Access to user profile and token
			profilePromise.then(function (profile) {
		// profile
		// $state.go('app.home');
			});

		}]); */

		//Called when login fails
		/*		lockProvider.on('loginFailure', function () {
		// If anything goes wrong
			console.log("failed");
		}); */


		// Remove back text 
		$ionicConfigProvider.backButton.previousTitleText("");
		//Setup Search Bar
		$ionicFilterBarConfigProvider.backdrop(false);
		$ionicFilterBarConfigProvider.placeholder("Search...");
		$ionicFilterBarConfigProvider.theme("dark");


		$stateProvider
			.state('app', {
				url: '/app',
				abstract: true,
				templateUrl: 'templates/menu.html',
				controller: 'AppCtrl'
			})

			.state('app.loading', {
				url: 'app.loading',
				views: {
					'menuContent': {
						templateUrl: 'templates/loading.html'
					},
					controller: 'loadingController '
				}
			})
			.state('app.home', {
				url: '/home',
				views: {
					'menuContent': {
						templateUrl: 'templates/home.html'
					},
					controller: 'homeController '
				}
			})
			.state('app.messages', {
				url: '/messages',
				views: {
					'menuContent': {
						templateUrl: 'templates/messages.html',
						controller: 'messagesController'
						//controller: 'pushNotifictionController'
					}
				}
			})
			.state('app.message', {
				url: '/message/:id',
				views: {
					'menuContent': {
						templateUrl: 'templates/message.html',
						controller: 'messageController'
					}
				}
			})
			.state('app.category', {
				url: '/category',
				views: {
					'menuContent': {
						templateUrl: 'templates/category.html',
						controller: 'categoryController'
					}
				}
			})
			.state('app.subcategory', {
				url: '/category/:parentcategory/:colour',
				views: {
					'menuContent': {
						templateUrl: 'templates/category.html',
						controller: 'categoryController'
					}
				}
			})
			.state('app.products', {
				url: '/products/:category/:colour',
				views: {
					'menuContent': {
						templateUrl: 'templates/products.html',
						controller: 'productsController'
					}
				}
			})
			.state('app.pestcategories', {
				url: '/pestcategories',
				views: {
					'menuContent': {
						templateUrl: 'templates/pestcategories.html',
						controller: 'pestIdentificationController'
					}
				}
			})

			.state('app.pestsubcategories', {
				url: '/pestcategories/:parentcategory',
				views: {
					'menuContent': {
						templateUrl: 'templates/pestcategories.html',
						controller: 'pestIdentificationController'
					}
				}
			})
			.state('app.pestCategory', {
			    url: '/pestCategory/:id/:colour',
			    views: {
			        'menuContent': {
			            templateUrl: 'templates/pestcategories.html',
			            controller: 'pestCategoryController'
			        }
			    }
			})

			.state('app.pestproducts', {
				url: '/pestproducts/:category',
				views: {
					'menuContent': {
						templateUrl: 'templates/products.html',
						controller: 'productsController'
					}
				}
			})
			.state('app.productdetail', {
				url: '/productdetail/:id/:colour',
				views: {
					'menuContent': {
						templateUrl: 'templates/productdetail.html',
						controller: 'productController'
					}
				}
			})
			.state('app.askanexpert', {
				url: '/askanexpert',
				views: {
					'menuContent': {
						templateUrl: 'templates/askanexpert.html',
						controller: 'askanexpertController'
					}
				}
			});
		// if none of the above states are matched, use this as the fallback
		$urlRouterProvider.otherwise('/app/loading'); // routing here until device ready --> Lessons learned.
	});
