var app = angular.module('efekto.controllers', [])

	.controller('AppCtrl', function ($scope, $ionicModal, $timeout, $ionicHistory, store, $ionicFilterBar, productService, messageService, $ionicPopup, $window, lock, $ionicModal, $ionicLoading) {

		// With the new view caching in Ionic, Controllers are only called
		// when they are recreated or on app start, instead of every page change.
		// To listen for when this page is active (for example, to refresh data),
		// listen for the $ionicView.enter event:
		//$scope.$on('$ionicView.enter', function(e) {
		//});
		$scope.TotalUnreadMessages = 0;
		// Form data for the login modal
		$scope.loginData = {};
		//Search products data
		$scope.searchProducts = [];
		// Triggered in the login modal to close it
		$scope.closeLogin = function () {
			$scope.logoutmodal.hide();
		};
		$scope.s = '';

		// Open the login modal
		$scope.login = function () {
			$scope.logoutmodal.show();
		};

		// Perform the login action when the user submits the login form
		$scope.doLogin = function () {
			console.log('Doing login', $scope.loginData);

			// Simulate a login delay. Remove this and replace with your login
			// code if using a login system
			$timeout(function () {
				$scope.closeLogin();
			}, 1000);
		};

		$scope.back = function () {
			$ionicHistory.goBack(-1);
		}

		$scope.showBack = function () {
			return $ionicHistory.currentView().backViewId != undefined;
		}

		$scope.showProductSearch = function () {
			return (($ionicHistory.currentView().url == "/app/category") || ($ionicHistory.currentView().url == "/app/home"));
		}

		$scope.showAttachImage = function () {
			return ($ionicHistory.currentView().url == "/app/askanexpert");
		}

		$scope.getUser = function (){
			if (store.get("profile")){
				return store.get("profile");
			}
			return null; 
		}
		$ionicModal.fromTemplateUrl('templates/logout.html', {
			scope: $scope
		}).then(function (modal) {
			$scope.logoutmodal = modal;
		});

		$scope.messagesSelector = function () {
		    if (!store.get('profile')) {
		        //$scope.logginin = true;
		        lock.show();
		    } else {            
		        var isExpert = false;
		        try {

		            if (store.get('profile') && store.get('profile').groups) {
		                isExpert = store.get('profile').groups.includes("Expert");
		            }
		        }
		        catch (err) {
		            isExpert = false;
		        }

		        isExpert == true ? $window.location.href = '#/app/messages' : $window.location.href = '#/app/message/' + store.get('profile').email;
		    };

		}


		$scope.logout = function(){
		    store.set("profile", null);
		    $scope.TotalUnreadMessages = 0;
			// Open the login modal
			$scope.logoutmodal.show();
		}
		//Product search bar\\
		function loadProductSearch() {
		    //$ionicLoading.show({ template: "Initialising Application..." });
		    $ionicLoading.show({
		        template: '<p>Getting things ready</p><i class="fa fa-gear fa-spin" style="font-size:48px"></i>'
		    });
			productService.getProducts("name,Category,id").then(function (success) {
				$scope.searchProducts = success.data;	        
			  $ionicLoading.hide();
			}, function (error) {
				$scope.error = error;

				var alertPopup = $ionicPopup.alert({
					title: 'Error',
					template: JSON.stringify(error)
				});
			});
		}

		function checkUnreadMessages(){
			var profile = $scope.getUser();
			var isExpert = false;
		    try{
		        try {

		            if (store.get('profile') && store.get('profile').groups) {
		                isExpert = store.get('profile').groups.includes("Expert");
		            }
		        }
		        catch (err) {
		            isExpert = false;
		        }

		    }
		    catch (err) {
		        isExpert = false;
		    }

			if (profile){
			    messageService.getTotalUnreadMessages(isExpert == true ? "User" : "Expert", isExpert == true ? "Expert" : profile.email).then(function (success) {
			        $scope.TotalUnreadMessages = success.data[0].TotalUnread;
			        if (isExpert) { cordova.plugins.notification.badge.set(success.data[0].TotalUnread); };
				}, function(error){
				});
			}}


		$scope.$on('$ionicView.enter', function (e) {		    
		    if ($scope.searchProducts.length < 1) {
		        loadProductSearch();
		    };
		    checkUnreadMessages();
		});
        
		$scope.cancelSearch = function () {
		    $scope.items = [];
		    $scope.productSearch = false;
		}



		var filterBarInstance;	
		$scope.getItems = function getItems() {
            $scope.productSearch = true;
		    $scope.items = $scope.searchProducts;		    
		}    
		$scope.showFilterBar = function () {
			getItems();
			$scope.productSearch = true;
			filterBarInstance = $ionicFilterBar.show({
				items: $scope.items,
				update: function (filteredItems, filterText) {

					$scope.items = filteredItems;
					if (filterText) {

						console.log(filterText);
					}
				},
				cancel: function () {
					$scope.items = [];
					$scope.productSearch = false;
				}
			});
		};
		$scope.refreshItems = function () {
			if (filterBarInstance) {
				filterBarInstance();
				filterBarInstance = null;
			}

			$timeout(function () {
				getItems();
				$scope.$broadcast('scroll.refreshComplete');
			}, 1000);
		};

	})

	.controller('homeController', function ($scope, $stateParams,store, $window) {
		//$scope.TotalUnreadMessages = 10;

	})
	.controller('messagesController', function ($scope, $stateParams, messageService, $ionicPopup, profileService, $ionicLoading, $q, store, lock, $ionicModal, $window) {
	    $ionicLoading.show();
		$scope.showSearch = true;
		$scope.messages = [];
		promises = [];
		var pushList = [];

		//$scope.badgeUpdate = function (unreadCount) {		    
		//    cordova.plugins.notification.badge.decrease(unreadCount);
		//}

		function initPage() {
		    if (!store.get('profile')) {
		        $ionicLoading.hide();
		        $scope.logginin = true;
		        lock.show();

			} else {
		        
				var prof = store.get('profile');
				var isExpert = false;
		        
		        try {

		            if (store.get('profile') && store.get('profile').groups) {
		                isExpert = store.get('profile').groups.includes("Expert");
		            }
		        }
		        catch (err) {
		            isExpert = false;
		        }
				if (isExpert) {
					
					promises.push(getMessage());
					$q.all(promises).then(function () {
						$scope.loading = false;																		
					});

				} else {
					//$window.location.href = '#/app/message/' + prof.email;
					$ionicLoading.hide();
				}
			}
		}

		$scope.$on('$ionicView.enter', function (e) {
		    $scope.logginin = false;
		    $scope.submitting = false;
		    $scope.completed = false;
			initPage();
			//getMessage();
		})


		// getMessage();

		function getMessage() {
			messageService.getConversationThread().then(function (success) {
				varlistMessages = success.data;	        

				$scope.conversations = success.data; // varlistMessages.Conversations();

				$scope.showSearch = false;
				$ionicLoading.hide();
			}, function (error) {
				$scope.error = error;
				$scope.showSearch = false;
				var alertPopup = $ionicPopup.alert({
					title: 'Error',
					template: JSON.stringify(error)
				});
				$ionicLoading.hide();
			});
		}

		$scope.search = function () {
			$scope.showSearch = true;
		}

	})

.controller('messageController', function ($scope, $stateParams, pushNotifictionService, $ionicPopup, messageService, store, $ionicLoading, $anchorScroll, $location, $window, $ionicModal) {

    var messages = [];
    var updateAsReadList = [];
    var isExpert = false;

    $ionicModal.fromTemplateUrl('templates/modal.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.modal = modal;
    });

    $scope.openModal = function (image) {
        $scope.modal.show()
        $scope.imgUrl = image
    }

    $scope.closeModal = function () {
        $scope.modal.hide();
    };

    initPage();
    $scope.clientEmail = $stateParams.id;
    var userDeviceId = "";

    function initPage() {
        if (!store.get('profile')) {
            $scope.logginin = true;
            lock.show();
        } else {

            try {

                if (store.get('profile') && store.get('profile').groups) {
                    isExpert = store.get('profile').groups.includes("Expert");
                }
            }
            catch (err) {
                isExpert = false;
            }
            $ionicLoading.show();
            getMessage();
        }
    };

    function getMessage() {
        pushNotifictionService.getPushMessages($stateParams.id).then(function (success) {
            for (var i = 0; i < success.data.length; i++) {
                if (success.data[i].image !== null)
                    success.data[i].image = "data:image/jpeg;base64," + success.data[i].image;

                if (isExpert == true && success.data[i].user == "User" && success.data[i].unread == 1) {
                    updateAsReadList.push(success.data[i].id)
                } else if (isExpert == false && success.data[i].user == "Expert" && success.data[i].unread == 1) {
                    updateAsReadList.push(success.data[i].id)
                }
                if (success.data[i].user == 'User') { userDeviceId = success.data[i].deviceid };
                messages.push(success.data[i]);
            }
            $scope.conversation = messages.sort(function (a, b) {
                return new Date(a.createdAt) - new Date(b.createdAt);
            });
            $ionicLoading.hide();

            updateAsRead(updateAsReadList);
            //$scope.gotoBottom();
        }, function (error) {
            $scope.error = error;
            $ionicLoading.hide();
            var alertPopup = $ionicPopup.alert({
                title: 'Error',
                template: JSON.stringify(error)
            });
        });
    }

    $scope.gotoBottom = function () {
        // set the location.hash to the id of
        // the element you wish to scroll to.
        $location.hash('bottom');

        // call $anchorScroll()
        $anchorScroll();
    };

    function updateAsRead(idList) {
        if (idList.length > 0) {
            for (var i = 0; i < idList.length; i++) {
                pushNotifictionService.updatePushMessageRead(idList[i]);
                if (!isExpert) {
                    cordova.plugins.notification.badge.set(0);
                } else {
                    cordova.plugins.notification.badge.decrease(idList.length);
                }

            }
        }
    };
    // pushNotifictionService.updatePushMessageRead('df5f59fa-585a-411a-9b5a-b27e93c9ba8e');
    $scope.message = {};
    var image = null;
    var self = this;
    $scope.postMessage = function postMessage(message) {
        $ionicLoading.show({ template: "Sending message..." });
        try {

            if (store.get('profile') && store.get('profile').groups) {
                isExpert = store.get('profile').groups.includes("Expert");
            }
        }
        catch (err) {
            isExpert = false;
        }
        var toSubmit = {};
        if (isExpert) {
            toSubmit.message = message;
            toSubmit.user = "Expert";
        } else {
            toSubmit.description = message
            toSubmit.user = "User";
        }
        if (isExpert) { toSubmit.profileImage = null } else { toSubmit.profileImage = store.get('profile').picture }
        toSubmit.email = $scope.clientEmail;
        toSubmit.userid = store.get('profile').user_id;
        toSubmit.deviceid = userDeviceId;//store.get('handle');
        toSubmit.profileImage = store.get('profile').picture;
        toSubmit.name = store.get('profile').name;
        toSubmit.unread = 1;

        // toSubmit.image = image;
        $scope.submitting = true;

        console.log(toSubmit.description);
        console.log(toSubmit.message);
        console.log(toSubmit.email)
        console.log(toSubmit.image);
        console.log(JSON.stringify(toSubmit));

        pushNotifictionService.postPushMessage(toSubmit).then(function (success) {
            $scope.submitting = false;
            $scope.completed = true;
            messages = [];
            conversation = [];
            $scope.mes = "";
            getMessage();
        }, function () {
            $ionicLoading.hide();
            // $scope.gotoBottom();
        });
    }


    

    //$scope.goToExpert = function goToExpert() { $window.location.href = '#/app/askanexpert' }
})

	.controller('categoryController', function ($scope, $stateParams, productService, $ionicLoading, $ionicPopup, store, $ionicFilterBar) {
		$scope.categories = [];
		$scope.catView = true;
		var parentcategory = $stateParams.parentcategory

		$scope.doRefresh = function () {
			store.set("categories", null);
			initPage();
		}

		var initPage = function () {
			$ionicLoading.show();
			if (parentcategory) {
				productService.getCategoriesByParent(parentcategory).then(function (response) {
					$scope.categories =  setVTags(response.data);
					$ionicLoading.hide();
					$scope.$broadcast('scroll.refreshComplete');
				}, function (error) {
					$scope.error = error;
					console.log(JSON.stringify(error));
					$ionicLoading.hide();
					$scope.$broadcast('scroll.refreshComplete');
					var alertPopup = $ionicPopup.alert({
						title: 'Error',
						template: JSON.stringify(error)
					});
				});
			} else {
				productService.getCategories("Products").then(function (response) {
					$scope.categories = setVTags(response.data);
					$ionicLoading.hide();
					$scope.$broadcast('scroll.refreshComplete');
				}, function (error) {
					$scope.error = error;
					console.log(JSON.stringify(error));
					$ionicLoading.hide();
					$scope.$broadcast('scroll.refreshComplete');
					var alertPopup = $ionicPopup.alert({
						title: 'Error',
						template: JSON.stringify(error)
					});
				});
			};
			function setVTags(categories){
				for(var i=0;i<categories.length;i++){
					categories[i].vtags =JSON.parse( categories[i].tags);	
				}
				return categories;
			}
		};

		$scope.$on('$ionicView.enter', function (e) {
			initPage();
		});

	})

	.controller('productsController', function ($scope, $stateParams, productService, $ionicLoading, $ionicPopup) {
		$scope.products = [];
		$ionicLoading.show();
		var category = $stateParams.category
		var colour = $stateParams.colour;

		if(colour){
			$scope.colour = colour;
		}else{
			$scope.colour = "#56ae46";
		}

		var initPage = function () {
			productService.getProductsByCategory(category).then(function (success) {
				$scope.products = success.data;
				$ionicLoading.hide();
			}, function (error) {
				$scope.error = error;

				var alertPopup = $ionicPopup.alert({
					title: 'Error',
					template: JSON.stringify(error)
				});
				$ionicLoading.hide();
			});
		}
		$scope.$on('$ionicView.enter', function (e) {
			initPage();
		});
	})

    	.controller('pestCategoryController', function ($scope, $stateParams, productService, $ionicLoading, store) {
    	    $scope.categories = [];
    	    var categoryId = $stateParams.id;

    	    var initPage = function () {
    	        $ionicLoading.show();
    	        if (categoryId) {
    	            productService.getCategoryById(categoryId).then(function (success) {
    	                $scope.categories = setVTags(success.data);
    	                $ionicLoading.hide();
    	            }, function (error) {
    	                $ionicLoading.hide();
    	            });
    	        } 
    	    }
    	    $scope.$on('$ionicView.enter', function (e) {
    	        initPage();
    	    });
    	    function setVTags(categories) {
    	        for (var i = 0; i < categories.length; i++) {
    	            categories[i].vtags = JSON.parse(categories[i].tags);
    	        }
    	        return categories;
    	    }

    	})
	.controller('pestIdentificationController', function ($scope, $stateParams, productService, $ionicLoading, store) {
		$scope.categories = [];
		var parentcategory = $stateParams.parentcategory
		$scope.doRefresh = function () {
			store.set("categories", null);
			initPage();
		}

		var initPage = function () {
			$ionicLoading.show();
			if (parentcategory) {
				productService.getCategoriesByParent(parentcategory, 'Pests').then(function (success) {
					$scope.categories = setVTags(success.data);
					$ionicLoading.hide();
				}, function (error) {
					$ionicLoading.hide();
				});
			} else {
				productService.getCategories('Pests').then(function (success) {
					$scope.categories = setVTags(success.data);
					$ionicLoading.hide();
				}, function (error) {
					$ionicLoading.hide();
				});
			}
		}
		$scope.$on('$ionicView.enter', function (e) {
			initPage();
		});
		function setVTags(categories){
			for(var i=0;i<categories.length;i++){
				categories[i].vtags =JSON.parse( categories[i].tags);	
			}
			return categories;
		}

	})

	.controller('productController', function ($scope, $stateParams, productService, $ionicLoading, store) {
		$scope.product = {};
		$scope.loading = true;
		var id = $stateParams.id;
		var colour = $stateParams.colour;

		if(!colour){
			$scope.colour = "#56ae46";
		}else{
			$scope.colour = colour;
		}

		var initPage = function () {
			//$ionicLoading.show();
			$scope.loading = true;
			productService.getProductById(id).then(function (success) {
				$scope.product = setVTags(success.data);
				$scope.loading = false;
			}, function (error) {
				$scope.loading = false;
			});

		}
		$scope.$on('$ionicView.enter', function (e) {
			initPage();
		})

		function setVTags(product){
			product.vtags =JSON.parse( product.tags);	
			return product;
		}

	})
	.controller('loadingController', function ($scope, $stateParams, productService, $ionicLoading) {
		$ionicLoading.show();
	})
		.controller('pushNotifictionController', function ($scope, $stateParams, pushNotifictionService, profileService, $ionicLoading, store, $ionicModal, lock, $ionicFilterBar) {
		var self = this;
		$scope.messages = [];
		self.profile = function () {
			return	store.get('profile');
		}
		console.log(JSON.stringify(self.profile));


		$scope.lock = lock;


		$ionicModal.fromTemplateUrl('templates/login.html', {
			scope: $scope
		}).then(function (modal) {
			$scope.loginin = modal;
		});

		$scope.closelogin = function (){
			$scope.loginin.hide();
		}

		function initPage() {

			if(!self.profile()){
				$scope.loginin.show();
				login();
			} else{
				$scope.showMessages();
			}
		}

		$scope.$on('$ionicView.enter', function (e) {
			initPage();
		})

		$scope.showMessages = function (){
			$ionicLoading.show(); 

			pushNotifictionService.getPushMessages(self.profile().user_id).then(function (success) {
				$scope.messages = success.data;

				$ionicLoading.hide();
			}
				, function (error) {
					// TODO: add error handling here
					$ionicLoading.hide();
				});
		}


		var login = function (){
			$scope.lock.signin({
				container: 'lock-container',
				authParams: {
					scope: 'openid offline_access',
					device: 'Mobile device'
				}
			}, function (profile, token, accessToken, state, refreshToken) {
				// Success callback
				store.set('profile', profile);
				store.set('token', token);
				store.set('accessToken', accessToken);
				store.set('refreshToken', refreshToken);
				console.log("logged in success");
				profileService.postProfile({
					"userid": profile.user_id,
					"profile": JSON.stringify(profile), 
					"picture": profile.picture,
					"deviceid": store.get("handle")
				});
				$scope.showMessages();			
				$scope.closelogin();
			}, function (error) {
				// Error callback
				console.log(JSON.stringify(error));
				$scope.logginin = false;
			});
		}


	});




