'use strict';
app.factory('messageService', ['$http', 'baseApiService', function ($http, baseApiService) {
	var messageServiceFactory = {};
	var conversationsList = [];


	var _postMessage = function (data) {
		var baseurl = baseApiService.getBaseUrl();

		var url = baseurl + "Messages/?&ZUMO-API-VERSION=2.0.0";
		return $http({
			url: url,
			data: data,
			method: "POST"
		}).then(function (results) {
			return results;
		});

	}

	messageServiceFactory.postMessage = _postMessage;

	//Get messages for experts
	var _getMessages = function (profileid) {
		var baseurl = baseApiService.getBaseUrl();

		var url = baseurl + "Messages/?&$filter=email eq '" + profileid + "' &ZUMO-API-VERSION=2.0.0";
		return $http({
			url: url,
			method: "GET"
		}).then(function (results) {
			return results;
		});

	}

	messageServiceFactory.getMessages = _getMessages;

	var _getConversationThread = function(){
		var baseurl = baseApiService.getCustomApiBaseUrl();

		var url = baseurl + "GetGroupedMessages";
		return $http({
			url: url,
			method: "GET"
		}).then(function (results) {
		return results;
		});

	}
	
	messageServiceFactory.getConversationThread = _getConversationThread;

	var _getTotalUnreadMessages = function(user,useremail){
		var baseurl = baseApiService.getCustomApiBaseUrl();

		var url = baseurl + "GetTotalUnreadMessages";
		return $http({
		    url: url,
		    params: { usertype: user, useremail: useremail},
			method: "GET"
		}).then(function (results) {
		return results;
		});

	}
	
	messageServiceFactory.getTotalUnreadMessages = _getTotalUnreadMessages;



	return messageServiceFactory;
}]);

