'use strict';
app.factory('productService', ['$http', 'baseApiService', 'store', function ($http, baseApiService, store) {
    var productServiceFactory = {};
    var allSearch = {};

    var _getProducts = function (fields) {
        var baseurl = baseApiService.getBaseUrl();
        //var url = baseurl + "Product? &$orderby=Order &ZUMO-API-VERSION=2.0.0";
        var url = baseurl + "Product?%24select=name%2CCategory%2Cid%2Cdescription &$orderby=Order &ZUMO-API-VERSION=2.0.0";
        return $http({
            url: url,
            method: "GET"
        }).then(function (results) {
            var allSearch = results;
            var urlcats = baseurl + "Categories?%24select=name%2Ccategorytype%2Cid%2Cparent%2Cdescription &$orderby=Order &ZUMO-API-VERSION=2.0.0";
            return $http({
                url: urlcats,
                method: "GET"
            }).then(function (catResults) {
                var i;
                for (i = 0; i < catResults.data.length; i++) {
                    catResults.data[i].Category = catResults.data[i]['categorytype'];
                    delete catResults.data[i].categorytype;
                    allSearch.data.push(catResults.data[i]);
                }
                return allSearch;
            });            
        });
    }
    productServiceFactory.getProducts = _getProducts;

    var _getCategories = function (type) {

        var baseurl = baseApiService.getBaseUrl();

        if (!type) {
            type = "Products"
        }

        if (store.get('categories') && store.get('categories').length > 0) {
            var toreturn = {
                then: function (callback) {
                    var storecategories = store.get('categories');
                    var filteredCategories = _.filter(storecategories, function (item) {
                        return item.parent == null && item.categorytype == type;
                    })
                    var categories = { data: filteredCategories };
                    callback(categories);
                }
            }

            return toreturn;
        } else {

            var url = baseurl + "Categories? &$orderby=Order &ZUMO-API-VERSION=2.0.0";
            return $http({
                url: url,
                method: "GET"
            }).then(function (results) {
                store.set('categories', results.data);

                var filteredCategories = _.filter(results.data, function (item) {
                    return item.parent == null && item.categorytype == type;
                })
                return { data: filteredCategories };
            });
        }
    }
    productServiceFactory.getCategories = _getCategories;

    var _getCategoriesByParent = function (categoryName, type) {
        var baseurl = baseApiService.getBaseUrl();

        if (!type) {
            type = "Products"
        }

        if (store.get("categories")) {
            var results = {
                then: function (callback) {
                    var storecategories = store.get("categories");
                    var filteredCategories = _.filter(storecategories, function (item) {
                        return item.parent == categoryName && item.categorytype == type;
                    })

                    callback({ data: filteredCategories });
                }
            }
            return results;
        }

        var url = baseurl + "categories?$filter=parent eq '" + categoryName + "' and categorytype eq '" + type + "' &$orderby=Order &ZUMO-API-VERSION=2.0.0";


        return $http({
            url: url,
            method: "GET"
        }).then(function (results) {
            return results;
        });

    }

    productServiceFactory.getCategoriesByParent = _getCategoriesByParent;

    var _getSubCategoriesByName = function (categoryName) {
        var baseurl = baseApiService.getBaseUrl();

        var url = baseurl + "Subcategories?$filter=categoryName eq '" + categoryName + "' &$orderby=Order &ZUMO-API-VERSION=2.0.0";
        return $http({
            url: url,

            method: "GET"
        }).then(function (results) {
            return results;
        });

    }

    productServiceFactory.getSubCategoriesByName = _getCategoryById;

    var _getCategoryById = function (categoryID) {
        var baseurl = baseApiService.getBaseUrl();

        var url = baseurl + "Categories?$filter=id eq '" + categoryID + "' and description ne null &$orderby=Order &ZUMO-API-VERSION=2.0.0";
        return $http({
            url: url,

            method: "GET"
        }).then(function (results) {
            return results;
        });

    }

    productServiceFactory.getCategoryById = _getCategoryById;

    var _getProductsByCategory = function (category) {
        var baseurl = baseApiService.getBaseUrl();

        var url = baseurl + "Product?$filter=Category eq '" + category + "' &$orderby=Order &ZUMO-API-VERSION=2.0.0";
        return $http({
            url: url,

            method: "GET"
        }).then(function (results) {
            return results;
        });

    }

    productServiceFactory.getProductsByCategory = _getProductsByCategory;


    var _getProductById = function (id) {
        var baseurl = baseApiService.getBaseUrl();

        var url = baseurl + "Product/" + id + "? &$orderby=Order &ZUMO-API-VERSION=2.0.0";
        return $http({
            url: url,

            method: "GET"
        }).then(function (results) {
            return results;
        });

    }

    productServiceFactory.getProductById = _getProductById;
    return productServiceFactory;
}]);




