'use strict';
app.factory('pushNotifictionService', ['$http', 'baseApiService', function ($http, baseApiService) {
    var pushnotificationServiceFactory = {};

	var _getPushMessages = function (profileid) {
		var baseurl = baseApiService.getBaseUrl();
	    var url = baseurl + "PushMessages/?&$filter=email eq '" + profileid + "' or send_to_all eq 'yes'&ZUMO-API-VERSION=2.0.0";		
		//var url = baseurl + "PushMessages/?ZUMO-API-VERSION=2.0.0";		
		return $http({
			url: url,
		       method: "GET"
		}).then(function (results) {		    
			return results; 
		});

	}

	pushnotificationServiceFactory.getPushMessages = _getPushMessages;

	var _getPushMessagesExpert = function (profileid) {
	    var baseurl = baseApiService.getBaseUrl();
	    //var url = baseurl + "PushMessages/?&$filter=user eq '" + profileid + "' or send_to_all eq 'yes'&ZUMO-API-VERSION=2.0.0";
	    var url = baseurl + "PushMessages/?ZUMO-API-VERSION=2.0.0";		
	    return $http({
	        url: url,
	        method: "GET"
	    }).then(function (results) {
	        return results;
	    });

	}

	pushnotificationServiceFactory.getPushMessagesExpert = _getPushMessagesExpert;

	var _getPushMessage = function (messageId) {
	    var baseurl = baseApiService.getBaseUrl();
	    //var url = baseurl + "PushMessages/?&$filter=user eq '" + profileid + "' or send_to_all eq 'yes'&ZUMO-API-VERSION=2.0.0";		
	    var url = baseurl + "PushMessages/" + messageId + "?ZUMO-API-VERSION=2.0.0";
	    return $http({
	        url: url,
	        method: "GET"
	    }).then(function (results) {
	        return results;
	    });
	}

	pushnotificationServiceFactory.getPushMessage = _getPushMessage;

	var _postPushMessage = function (data) {
	    var baseurl = baseApiService.getBaseUrl();
	    //var url = baseurl + "PushMessages/?&$filter=user eq '" + profileid + "' or send_to_all eq 'yes'&ZUMO-API-VERSION=2.0.0";		
	    var url = baseurl + "PushMessages/?&ZUMO-API-VERSION=2.0.0";
	    return $http({
	        url: url,
	        data: data,
	        method: "POST"
	    }).then(function (results) {
	        return results;
	    });
	}

	pushnotificationServiceFactory.postPushMessage = _postPushMessage;

	var _updatePushMessageRead = function (messageId) {
	    var baseurl = baseApiService.getBaseUrl();
	    //var url = baseurl + "PushMessages/?&$filter=user eq '" + profileid + "' or send_to_all eq 'yes'&ZUMO-API-VERSION=2.0.0";		
	    var url = baseurl + "PushMessages/" + messageId + "/?ZUMO-API-VERSION=2.0.0";
	    return $http({
	        url: url,
	        data: {"unread": 0},
	        method: "PATCH"
	    }).then(function (results) {
	        return results;
	    });
	}

	pushnotificationServiceFactory.updatePushMessageRead = _updatePushMessageRead;

	return pushnotificationServiceFactory; 
}]);

